import 'package:flutter/material.dart';
import 'package:flutter/services.dart';


 abstract class CommonTextField extends TextFormField {
  CommonTextField({
    required FormFieldValidator<String> validator,
    required TextInputType keyboardType,
    required String labelText,
    //////////////////////////
    bool showErrorAlways = true,
    TextEditingController? controller,
    bool? enabled,
    bool readOnly = false,
    String? initialValue,
    List<TextInputFormatter>? inputFormatters,
    TextAlign textAlign = TextAlign.start,
  }) : super(
          controller: controller,
          enabled: enabled,
          maxLines: null,
          keyboardType: keyboardType,
          validator: validator,
          inputFormatters: inputFormatters,
          decoration: InputDecoration().copyWith(
            labelText: labelText,
          ),
          autovalidateMode: showErrorAlways
              ? AutovalidateMode.always
              : AutovalidateMode.onUserInteraction,
          initialValue: initialValue,
          readOnly: readOnly,
          textAlign: textAlign,
        );
}
